#include "JNeatViewObj.h"
#include "JConvertObj.h"
#include "JLinkObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JBlockData.h"
#include "JBytesData.h"
#include "JCharacter.h"
#include "JStringData.h"
#include "JStringProperty.h"
#include "JIntegerProperty.h"
#include "JSocketException.h"
#include "JUnknownHostException.h"
#include "VizCommands.h"
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <time.h>
char* newstrcpy( char* x ) {
	char* xx = (char*)malloc( strlen( x ) + 1 );
	strcpy( xx, x );
	return( xx );
}


char* theJNeatViewObj = JNeatViewObj().Register();		  
void JNeatViewObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "address", address);
  putInteger(os, "port", port);
  putObject( os, "fileToLoad", fileToLoad );
  putObject( os, "command1", command1 );
  putObject( os, "command2", command2 );
  putObject( os, "command3", command3 );
  putObject( os, "command4", command4 );
  putObject( os, "command5", command5 );
  putObject( os, "command6", command6 );
  putObject( os, "command7", command7 );
  putObject( os, "command8", command8 );
  putInteger( os, "minX", minX );
  putInteger( os, "maxX", maxX );
  putInteger( os, "minY", minY );
  putInteger( os, "maxY", maxY );
  putInteger( os, "minZ", minZ );
  putInteger( os, "maxZ", maxZ );
  putInteger( os, "calibrated", calibrated );
  putInteger( os, "initial_X_values_set", initial_X_values_set );
  putInteger( os, "initial_Y_values_set", initial_Y_values_set );
  putInteger( os, "initial_Z_values_set", initial_Z_values_set );
  putInteger( os, "minSignal1", minSignal1 );
  putInteger( os, "maxSignal1", maxSignal1 );
  putInteger( os, "initial_signal1_values_set", initial_signal1_values_set );
  putInteger( os, "minSignal2", minSignal2 );
  putInteger( os, "maxSignal2", maxSignal2 );
  putInteger( os, "initial_signal2_values_set", initial_signal2_values_set );
  putInteger( os, "minSignal3", minSignal3 );
  putInteger( os, "maxSignal3", maxSignal3 );
  putInteger( os, "initial_signal3_values_set", initial_signal3_values_set );
  putInteger( os, "minSignal4", minSignal4 );
  putInteger( os, "maxSignal4", maxSignal4 );
  putInteger( os, "initial_signal4_values_set", initial_signal4_values_set );
  putInteger( os, "minSignal5", minSignal5 );
  putInteger( os, "maxSignal5", maxSignal5 );
  putInteger( os, "initial_signal5_values_set", initial_signal5_values_set );
}

void JNeatViewObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject *obj = getObject(dict, "address");
  if (obj) address = *(JString*)obj;
  port = getInteger(dict, "port");
  obj = getObject(dict, "fileToLoad");
  if (obj) fileToLoad = *(JString*)obj;
  obj = getObject(dict, "command1");
  if (obj) command1 = *(JString*)obj;
  obj = getObject(dict, "command2");
  if (obj) command2 = *(JString*)obj;
  obj = getObject(dict, "command3");
  if (obj) command3 = *(JString*)obj;
  obj = getObject(dict, "command4");
  if (obj) command4 = *(JString*)obj;
  obj = getObject(dict, "command5");
  if (obj) command5 = *(JString*)obj;
  obj = getObject(dict, "command6");
  if (obj) command6 = *(JString*)obj;
  obj = getObject(dict, "command7");
  if (obj) command7 = *(JString*)obj;
  obj = getObject(dict, "command8");
  if (obj) command8 = *(JString*)obj;

  minX = getInteger( dict, "minX" );
  maxX = getInteger( dict, "maxX" );
  minY = getInteger( dict, "minY" );
  maxY = getInteger( dict, "maxY" );
  minZ = getInteger( dict, "minZ" );
  maxZ = getInteger( dict, "maxZ" );
  calibrated = getInteger( dict, "calibrated" );
  calibrated = 1;
  initial_X_values_set = getInteger( dict, "initial_X_values_set" );
  initial_Y_values_set = getInteger( dict, "initial_Y_values_set" );
  initial_Z_values_set = getInteger( dict, "initial_Z_values_set" );
  minSignal1 = getInteger( dict, "minSignal1" );
  maxSignal1 = getInteger( dict, "maxSignal1" );
  initial_signal1_values_set = getInteger( dict, "initial_signal1_values_set" );
  minSignal2 = getInteger( dict, "minSignal2" );
  maxSignal2 = getInteger( dict, "maxSignal2" );
  initial_signal2_values_set = getInteger( dict, "initial_signal2_values_set" );
  minSignal3 = getInteger( dict, "minSignal3" );
  maxSignal3 = getInteger( dict, "maxSignal3" );
  initial_signal3_values_set = getInteger( dict, "initial_signal3_values_set" );
  minSignal4 = getInteger( dict, "minSignal4" );
  maxSignal4 = getInteger( dict, "maxSignal4" );
  initial_signal4_values_set = getInteger( dict, "initial_signal4_values_set" );
  minSignal5 = getInteger( dict, "minSignal5" );
  maxSignal5 = getInteger( dict, "maxSignal5" );
  initial_signal5_values_set = getInteger( dict, "initial_signal5_values_set" );
}

const char* JNeatViewObj::className() const { return "JNeatViewObj";}
JObject* JNeatViewObj::clone() const { 
//    JComponent::debug( "Clone JNeatViewObj" );
    return new JNeatViewObj(*this);
}

JNeatViewObj::JNeatViewObj() {
  address = "localhost";
  port = 3502;
  connected = false;
  enabled = false;
  ssequence = 1;
  igm = 12;
  ogm = 1;
  sendCalibrationToViz = false;
  initial_signal1_values_set = false;
  initial_signal2_values_set = false;
  initial_signal3_values_set = false;
  initial_signal4_values_set = false;
  initial_signal5_values_set = false;
  	sendCommand1 = false;
	sendCommand2 = false;
	sendCommand3 = false;
	sendCommand4 = false;
	sendCommand5 = false;
	sendCommand6 = false;
	sendCommand7 = false;
	sendCommand8 = false;

  sendFileLoadRequest = true;
  fileToLoad = JString();
//  JComponent::debug( "create JNeatViewObj" );
}

JNeatViewObj::JNeatViewObj(const JNeatViewObj& obj) { *this=obj;}
JNeatViewObj::~JNeatViewObj() { close();}


void JNeatViewObj::startup() {
    sendFileLoadRequest = true;
}

void JNeatViewObj::reset() { 
  connected = false;
  data.Dereference();
  socket.close();
}

/**
 *  open
 *
 *  Purpose:
 *      Start a thread (if not already running) to connect to external program
 *      via sockets.
 */

void JNeatViewObj::open() {
  cs.lock();
  if (!connected) {
    thread = JThread(this);
    thread.start();
    thread.setPriority(JThread::TNORM_PRIORITY+1);
  }
  cs.unlock();
}


/**
 *  close
 *
 *  Purpose:
 *      Stop the thread (if not already stopped) that is connected to an
 *      external program via sockets.
 */

void JNeatViewObj::close() {
  cs.lock();
  if (connected) {
    connected = false;
    thread.setPriority(JThread::TNORM_PRIORITY);
    closeSocket();
    thread.waitFor();
    repaint();
    ssequence = 1;
  }
  cs.unlock();
}

void JNeatViewObj::openSocket() {
  boolean isIPAddr = true;
  for (int i=0; address[i]; i++) 
    if (JCharacter::isAlpha(address[i]))
      isIPAddr = false;
  if (isIPAddr) {
    JInetAddress inet = JInetAddress(
      JInetAddress::getAddrByJString(address));
    socket = JSocket(inet, port);
    address = inet.getAddressJString();
  } else {
    JInetAddress inet = JInetAddress(address);
    socket = JSocket(inet, port);
    address = inet.getHostName();
  }
}

boolean JNeatViewObj::connectSocket() {
  if (socket.connect()) {
    sis = JSocketInputStream(socket);
    sos = JSocketOutputStream(socket);
    return true;
  }
  return false;
}

void JNeatViewObj::closeSocket() {
  try {
    socket.close();
  } catch (JException *e) {
    delete e;
  }
}


/** Get the output JStringData prepared to go outside the module */
void JNeatViewObj::access(int n, JLinkObj& link, const JDataType& _data) { 
    JSTRING(_data) = defList; 
    waitUntilBroadcasted = false; 
}


/**
 *  Module characteristics associated with inputs.
 */

/**
 *  inputType
 *  
 *  Purpose:  
 *     get the input type corresponding to location
 *     All input types are int except for DEF list, which is a string
 */

int JNeatViewObj::inputType(int n) { 
    if ( n == 8) return JBytesData::id;
    else return JIntegerData::id;
}


/**
 *  inputTag
 *
 *  Purpose:
 *     provide a JString describing an input.
 */

JString JNeatViewObj::inputTag(int n) {
  char* tag[] = {
      // left inputs
        "command 1",            // 0
        "command 2",            // 1
	    "command 3",            // 2
	    "command 4",     // 3
        "command 5",     // 4
        "command 6",     // 5
        "command 7",     // 6
        "command 8",     // 7
        "transformer bytes to viz", // 8

      // top inputs
        "enable(logical)",  // 9
        "timer_sampled",    // 10
        "calibrate",        // 11
//        "send_calibration", // 12
  };
  return( tag[n] );
}


/**
 *  inputAllowed
 *
 *  Purpose:
 *     determines whether a new connection can be made to an input.
 *     For this module, multiple bytes connections are allowed, but only 
 *     a single "enable" connection is allowed.
 */

boolean JNeatViewObj::inputAllowed(int n) { 
    if ( n == 8 ) {
        return( true );
    } else {
        return !inputSet(n).last();
    }
}


/** 
 *  inputArea
 *
 *  Purpose:
 *     Defines area within module associated with each input.
 *     x,y,z,signals 1-5, and transformer data are on left
 *     enable, timer sampling, calibration, and send calibration are on top
 */

JFRect JNeatViewObj::inputArea(int n) {
  if (n < ENABLED) return leftArea(n, 0, 9);
  return topArea(n, ENABLED, 3);
}



/**
 *  inputFace
 *
 *  Purpose:
 *     Indicates which face on the module rectangle is associated with an input.
 */

int JNeatViewObj::inputFace(int n) {
  if (n < ENABLED) return LEFT;
  return TOP;
}


/**
 *  inputPoint
 *
 *  Purpose:
 *     Given an input, provides the exact location of the connection
 *     to the module for that input.
 */

JFPoint JNeatViewObj::inputPoint(int n, JLinkObj& link) {
  if (n < ENABLED) return leftPoint(n, link, 0, ENABLED);
  return topPoint(n, link, ENABLED, 3);
}


/**
 *  Module characteristics associated with outputs
 */

/**
 *  outputTag
 *
 *  Purpose:
 *      Provide a string description of an output.  This module has a
 *      single output which is a list of DEF names in the WRL file
 *      that was loaded into viz.
 */

JString JNeatViewObj::outputTag(int n) { 
    return( "DEF list" ); 
}


/**
 *  outputType
 *
 *  Purpose:  
 *      Provide a data type for an output.  This module has a single output
 *      which is a string.
 */

int JNeatViewObj::outputType(int n) { 
    return JStringData::id;
} 

JFRect JNeatViewObj::outputArea(int n) { 
    return rightArea(n, 0, 1, 0, 1);
}



JFPoint JNeatViewObj::outputPoint(int n, JLinkObj& link) { 
    return rightPoint(n, link, 0, 1, 0, 1);
}

void JNeatViewObj::paint(JGraphics g, double dx, double dy, JRegion& rgn, double scale) {
  JAddObj::paint(g, dx, dy, rgn, scale);
  JRect rect = getIExtent(dx, dy, scale);
  int kw = depth2*3;
  if ((rect.width > kw) && (rect.height > kw)) {
    if (connected > true) g.setJColor(JColor::red);
    else if (connected) g.setJColor(JColor::yellow);
    else g.setJColor(JColor::red.darker());
    g.fillRect(rect.x+depth2, rect.y+depth2, depth2, depth2);
  }
}

void JNeatViewObj::draw(JGraphics g, int x, int y, int w, int h) {
  int dh = h/3;
  int dy = h/12;
  JRect rect1(x, y+dy, w, dh);
  JRect rect2(x, y+h/3, w, dh);
  JRect rect3(x, y+h*2/3-dy, w, dh);
  drawText(g, "Viz", rect1);
  drawText(g, "Client", rect2);
  drawText(g, address+":"+JInteger::toJString(port), rect3);
}


/**
 *  startCalibration
 *
 *  Purpose:
 *      Start calibration for this module, reset all values.
 */

void JNeatViewObj::startCalibration() {
    calibrating = true;
    calibrated = false;
    initial_X_values_set = false;
    initial_Y_values_set = false;
    initial_Z_values_set = false;
    initial_signal1_values_set = false;
    initial_signal2_values_set = false;
    initial_signal3_values_set = false;
    initial_signal4_values_set = false;
    initial_signal5_values_set = false;
}


/**
 *  endCalibration
 *
 *  Purpose:
 *      End calibration for this module.
 */

void JNeatViewObj::endCalibration() {
    calibrating = false;
    if ( initial_X_values_set && initial_Y_values_set ) {
        calibrated = true;
    }
}

/**
 *  engine
 *
 *  Purpose:
 *     The main processing engine for this module, called whenever
 *     data is received on an incoming visual link.
 */
void JNeatViewObj::engine(int n, JLinkObj& link) {
    switch (n) {
    case X:
        link.access(JIntegerData(x));
		if ( x ) {
			sendCommand1 = true;
		} else {
			sendCommand1 = false;
		}
        if ( calibrating ) {
            if ( !initial_X_values_set ) {
                minX = maxX = x;
                initial_X_values_set = true;
            } else if ( x < minX ) {
                minX = x;
            } else if ( x > maxX ) {
                maxX = x;
            }
        }
        break;
    case Y:
        link.access(JIntegerData(y));
		if ( y ) {
			sendCommand2 = true;
		} else {
			sendCommand2 = false;
		}
        if ( calibrating ) {
            if ( !initial_Y_values_set ) {
                minY = maxY = y;
                initial_Y_values_set = true;
            } else if ( y < minY ) {
                minY = y;
            } else if ( y > maxY ) {
                maxY = y;
            }
        }
        break;
    case Z:
        link.access(JIntegerData(z));
		if ( z ) {
			sendCommand3 = true;
		} else {
			sendCommand3 = false;
		}
        if ( calibrating ) {
            if ( !initial_Z_values_set ) {
                minZ = maxZ = z;
                initial_Z_values_set = true;
            } else if ( z < minZ ) {
                minZ = z;
            } else if ( z > maxZ ) {
                maxZ = z;
            }
        }
        break;
    case SIGNAL1:
        link.access(JIntegerData(signal1));
		if ( signal1 ) {
			sendCommand4 = true;
		} else {
			sendCommand4 = false;
		}
        if ( calibrating ) {
            if ( !initial_signal1_values_set ) {
                minSignal1 = maxSignal1 = signal1;
                initial_signal1_values_set = true;
            } else if ( signal1 < minSignal1 ) {
                minSignal1= signal1;
            } else if ( signal1> maxSignal1 ) {
                maxSignal1 = signal1;
            }
        }
        break;
    case SIGNAL2:
        link.access(JIntegerData(signal2));
		if ( signal2 ) {
			sendCommand5 = true;
		} else {
			sendCommand5 = false;
		}
        if ( calibrating ) {
            if ( !initial_signal2_values_set ) {
                minSignal2 = maxSignal2 = signal2;
                initial_signal2_values_set = true;
            } else if ( signal2< minSignal2 ) {
                minSignal2 = signal2;
            } else if ( signal2 > maxSignal2 ) {
                maxSignal2 = signal2;
            }
        }
        break;
    case SIGNAL3:
        link.access(JIntegerData(signal3));
		if ( signal3 ) {
			sendCommand6 = true;
		} else {
			sendCommand6 = false;
		}
        if ( calibrating ) {
            if ( !initial_signal3_values_set ) {
                minSignal3 = maxSignal3 = signal3;
                initial_signal3_values_set = true;
            } else if ( signal3 < minSignal3 ) {
                minSignal3 = signal3;
            } else if ( signal3 > maxSignal3) {
                maxSignal3 = signal3;
            }
        }
        break;
    case SIGNAL4:
        link.access(JIntegerData(signal4));
		if ( signal4 ) {
			sendCommand7 = true;
		} else {
			sendCommand7 = false;
		}
        if ( calibrating ) {
            if ( !initial_signal4_values_set ) {
                minSignal4 = maxSignal4 = signal4;
                initial_signal4_values_set = true;
            } else if ( signal4 < minSignal4 ) {
                minSignal4 = signal4;
            } else if ( signal4 > maxSignal4 ) {
                maxSignal4 = signal4;
            }
        }
        break;
    case SIGNAL5:
        link.access(JIntegerData(signal5));
		if ( signal5 ) {
			sendCommand8 = true;
		} else {
			sendCommand8 = false;
		}
        if ( calibrating ) {
            if ( !initial_signal5_values_set ) {
                    minSignal5 = maxSignal5 = signal5;
                initial_signal5_values_set = true;
            } else if ( signal5 < minSignal5 ) {
                minSignal5 = signal5;
            } else if ( signal5 > maxSignal5 ) {
                maxSignal5 = signal5;
            }
        }
        break;
    case TRANSFORMER_COMMAND:
        cs.lock();
        if (connected) {
        try {
            uchar ch = (uchar)(0);
            JBlock data;
            link.access(JBlockData(data));
            ushort dsize = 2 + data.size();
            sos << JBlock(dsize) + JBlock(ssequence)+JBlock(ch)+data;
            ssequence = (ssequence%128)+1;
        } catch (JException *e) {
            delete e;
        }
        }
        cs.unlock();
        break;
    case ENABLED:
        link.access(JIntegerData(enabled));
        if (enabled && !connected) open();
        else if (!enabled && connected) close();
        break;
    case TIMER_SAMPLED:
        link.access(JIntegerData(timer_sampled));
        break;
    case CALIBRATING:
        link.access(JIntegerData(calibrating));
        break;
    case SEND_CALIBRATION:
        link.access(JIntegerData(sendCalibrationToViz));
        break;
    default:
        break;
    }
    if ( n == TIMER_SAMPLED ) {
      if ( timer_sampled && calibrated ) {
         cs.lock();
         if (connected) {
           try {
             uchar ch = (uchar)(0);
             int command = MAIN_DATA;
             int numberSignals = 5;
             JBlock dataOut = JBlock(command) + JBlock(x) + JBlock(y) + JBlock(z) + JBlock(numberSignals) + JBlock(signal1) + JBlock(signal2) + JBlock(signal3) + JBlock(signal4) + JBlock(signal5);
             ushort dsize = 2 + dataOut.size();

			 if ( sendCommand1 && ( command1.length() > 0 )) {
				 sos << JBlock( command1 + "\n" );
			 }
			 if ( sendCommand2 && ( command2.length() > 0 )) {
				 sos << JBlock( command2 + "\n" );
			 }
			 if ( sendCommand3 && ( command3.length() > 0 )) {
				 sos << JBlock( command3 + "\n" );
			 }
			 if ( sendCommand4 && ( command4.length() > 0 )) {
				 sos << JBlock( command4 + "\n" );
			 }
			 if ( sendCommand5 && ( command5.length() > 0 )) {
				 sos << JBlock( command5 + "\n" );
			 }
			 if ( sendCommand6 && ( command6.length() > 0 )) {
				 sos << JBlock( command6 + "\n" );
			 }
			 if ( sendCommand7 && ( command7.length() > 0 )) {
				 sos << JBlock( command7 + "\n" );
			 }
			 if ( sendCommand8 && ( command8.length() > 0 )) {
				 sos << JBlock( command8 + "\n" );
			 }


             //sos << JBlock("right\n");
             ssequence = (ssequence%128)+1;
           } catch (JException *e) {
             delete e;
           }
         }
         cs.unlock();
	  }
    } else if ( n == CALIBRATING ) {
      if ( calibrating ) {
          startCalibration();
      } else {
          endCalibration();
          sendCalibrationToViz = true;
          sendFileLoadRequest = true;
      }
    } else if ( n == SEND_CALIBRATION ) {
      sendCalibrationToViz = true;
    }
    if ( sendCalibrationToViz ) {
      if ( !calibrating ) {
          if ( !initial_X_values_set ) {
              minX = maxX = 0;
          }
          if ( !initial_Y_values_set ) {
              minY = maxY = 0;
          }
          if ( !initial_Z_values_set ) {
              minZ = maxZ = 0;
          }
          if ( !initial_signal1_values_set ) {
              minSignal1 = maxSignal1 = 0;
          }
          if ( !initial_signal2_values_set ) {
              minSignal2 = maxSignal2 = 0;
          }
          if ( !initial_signal3_values_set ) {
              minSignal3 = maxSignal3 = 0;
          }
          if ( !initial_signal4_values_set ) {
              minSignal4 = maxSignal4 = 0;
          }
          if ( !initial_signal5_values_set ) {
              minSignal5 = maxSignal5 = 0;
          }
          cs.lock();
          if (connected) {
            try {
                uchar ch = (uchar)(0);
                int command = MAIN_CALIBRATION;
                int numberSignals = 5;
        	    JBlock dataOut = JBlock(command) + JBlock(minX) + JBlock(maxX) + JBlock(minY) + JBlock(maxY) + JBlock(minZ) + JBlock(maxZ) + JBlock( numberSignals) + JBlock(initial_signal1_values_set) + JBlock(minSignal1) + JBlock(maxSignal1) + JBlock(initial_signal2_values_set) + JBlock(minSignal2) + JBlock(maxSignal2) + JBlock(initial_signal3_values_set) + JBlock(minSignal3) + JBlock(maxSignal3) + JBlock(initial_signal4_values_set) + JBlock(minSignal4) + JBlock(maxSignal4) + JBlock(initial_signal5_values_set) + JBlock(minSignal5) + JBlock(maxSignal5);
                ushort dsize = 2 + dataOut.size();
                sos << JBlock(dsize) + JBlock(ssequence)+JBlock(ch)+dataOut;
                ssequence = (ssequence%128)+1;
            } catch (JException *e) {
                delete e;
            }
          }
          cs.unlock();
          sendCalibrationToViz = false;
      }
      if ( sendFileLoadRequest ) {
          cs.lock();
          if (connected) {
            try {
//                JComponent::debug( "sending file load request" );
                if ( fileToLoad.length() > 0 ) {
                    uchar ch = (uchar)(0);
                    int command = FILE_LOAD_REQUEST;
        	        JBlock dataOut = JBlock(command) + JBlock(fileToLoad);
                    ushort dsize = 2 + dataOut.size();
                    sos << JBlock(dsize) + JBlock(ssequence)+JBlock(ch)+dataOut;
                    ssequence = (ssequence%128)+1;
                }
                sendFileLoadRequest = 0;
            } catch (JException *e) {
                delete e;
            }
          }
          cs.unlock();
      }
  } 
}


JArray JNeatViewObj::getProperties() {
  JArray properties = JAddObj::getProperties();
  properties.append(JStringProperty("hostName/IPaddress", address));
  properties.append(JIntegerProperty("port", port, 1024, 5000));
  properties.append(JStringProperty("fileToLoad", fileToLoad));
  properties.append(JStringProperty("command1", command1));
  properties.append(JStringProperty("command2", command2));
  properties.append(JStringProperty("command3", command3));
  properties.append(JStringProperty("command4", command4));
  properties.append(JStringProperty("command5", command5));
  properties.append(JStringProperty("command6", command6));
  properties.append(JStringProperty("command7", command7));
  properties.append(JStringProperty("command8", command8));
  return properties;
}

boolean JNeatViewObj::updateProperty(JProperty& prop) {
  if (JAddObj::updateProperty(prop)) return true;
  boolean changed = false;
  boolean oldenabled = enabled;
  close();
  if (prop.getName() == JString("port")) {
    port = ((JIntegerProperty*)&prop)->value;
    changed = true;
  } else if (prop.getName() == JString("hostName/IPaddress")) {
    address = ((JStringProperty*)&prop)->value;
    changed = true;
  } else if (prop.getName() == JString("fileToLoad")) {
      fileToLoad = ((JStringProperty*)&prop)->value;
      changed=true;
      sendFileLoadRequest = true;
  } else if (prop.getName() == JString("command1")) {
      command1 = ((JStringProperty*)&prop)->value;
  } else if (prop.getName() == JString("command2")) {
      command2 = ((JStringProperty*)&prop)->value;
  } else if (prop.getName() == JString("command3")) {
      command3 = ((JStringProperty*)&prop)->value;
  } else if (prop.getName() == JString("command4")) {
      command4 = ((JStringProperty*)&prop)->value;
  } else if (prop.getName() == JString("command5")) {
      command5 = ((JStringProperty*)&prop)->value;
  } else if (prop.getName() == JString("command6")) {
      command6 = ((JStringProperty*)&prop)->value;
  } else if (prop.getName() == JString("command7")) {
      command7 = ((JStringProperty*)&prop)->value;
  } else if (prop.getName() == JString("command8")) {
      command8 = ((JStringProperty*)&prop)->value;
  }
  if (oldenabled) open();
  if (changed) repaint();
  return changed;
}


/**
 *  processInputStream
 *
 *  Purpose:
 *      Called to process any input received from viz module.  Not quite
 *      done, still has problem with sockets, won't work if sending side message
 *      is broken and not received as unit.  For the moment, these messages
 *      are so infrequent and so small it is probably not an issue.
 *
 *      There are two types of messages that can be sent from viz back to
 *      this module.  The first is a "calibrate me" message, indicated by
 *      a single character 'c'.  The second is a list of DEF names from the
 *      WRL file loaded into viz.  This is to allow JTrans2 module to deal
 *      with objects by DEF name.
 */

void JNeatViewObj::processInputStream() {
  while (connected > true) {
    try {
      sis >> defList;
      int defListLen = defList.length();
      if ( defListLen > 1 ) {
          if ( !waitUntilBroadcasted ) {
            waitUntilBroadcasted = true;
            broadcast( 0 );
          }
      } else if ( defListLen == 1 ) {
          if ( defList[0] == 'c' ) {
              sendCalibrationToViz = true;
              sendFileLoadRequest = true;
          } 
      }
    } catch (JException *e) {
      delete e;
      return;
    }
  }
}



void JNeatViewObj::run() {
    waitUntilBroadcasted = false;
RETRY:
  try {
    openSocket();
  } catch (JException *e) {
    delete e;
    closeSocket();
    return;
  }
  connected = true;
  repaint();
  try {
    while (connected) {
      if (connectSocket()) break;
      JThread::sleep(100);
    }
    if (!connected) {
      closeSocket();
      connected = false;
      repaint();
      return;
    }
  } catch (JException *e) {
    delete e;
    closeSocket();
    if (connected) goto RETRY;
    repaint();
    return;
  }
  connected++;
  repaint();
  processInputStream();
  if (connected > true) {
    closeSocket();
    goto RETRY;
  }
}

